<template>
	<div class="mx-auto flex-col md:rounded bg-white w-full md:w-570 lg:w-690 px-4 md:px-6 lg:px-10 py-6 lg:py-10 mb-2">
		<div class="flex flex-col md:flex-row justify-between">
			<MkStepProgress
				:step-title="title"
				:step-number="stepNumber"
				:class-active="stepsCompleted == 2 ? 'active' : ''"
			/>
		</div>
		<ValidationObserver v-if="stepsCompleted == 2" ref="create_account_validation_observer">
			<div>
				<MkNotificationSuccess v-if="isUserExists" class="my-4" :is-create-account="true" @sign-in="showLogin()" />
			</div>
			<div class="mt-6 md:mt-8 lg:mt-10">
				<div v-if="!registerUser">
					<MkInput
						id="quick_reg_email_address"
						class="mb-6 lg:mb-10"
						:value="value['quick_reg_email_address']"
						:loading="checkingStatus"
						:disable-input="checkingStatus"
						rules="required|email"
						variant="outline"
						label="Email"
						vid="quick_reg_email_address"
						@input="
							updateForm('quick_reg_email_address', $event);
							isUserExists = false;
						"
					/>
					<div class="grid-cols-1 lg:gap-10 lg:grid-cols-2 grid w-full mt-2">
						<MkInput
							class="mb-4"
							rules="required|alpha_spaces"
							:value="value['quick_reg_first_name']"
							variant="outline"
							label="First name"
							@input="updateForm('quick_reg_first_name', $event)"
						/>
						<MkInput
							class="mb-4"
							rules="required|alpha_spaces"
							:value="value['quick_reg_last_name']"
							variant="outline"
							label="Last name"
							@input="updateForm('quick_reg_last_name', $event)"
						/>
					</div>
					<div class="grid-cols-1 lg:gap-10 lg:grid-cols-2 grid w-full mt-2">
						<div class="relative">
							<MkInput
								id="quick_reg_password"
								class=""
								rules="required|valid_password"
								:value="value['quick_reg_password']"
								variant="outline"
								label="Password"
								:type="'password'"
								vid="quick_reg_password"
								@input="updateForm('quick_reg_password', $event)"
							/>
							<div
								class="inline-block absolute right-0 top-0 transform translate-y-5 group p-0.5 mk-tooltip"
								role="tooltip"
								tabindex="0"
							>
								<span class="icon-notification" aria-label="Features auto-refills tooltip"></span>
								<MkCartTooltip class="hidden group-hover:block" :rotate-left="true" :icon-position="toolTipPosition">
									<template #tooltipRightValue>
										<p>8 character min.</p>
										<p>1 lowercase letter</p>
										<p>1 uppercase letter</p>
										<p>1 number</p>
										<p>1 special character</p>
									</template>
								</MkCartTooltip>
							</div>
						</div>
						<MkInput
							class=""
							:value="value['quick_reg_confirm_password']"
							variant="outline"
							label="Confirm password"
							:type="'password'"
							rules="required|confirmed:quick_reg_password"
							@input="updateForm('quick_reg_confirm_password', $event)"
						/>
					</div>
				</div>
				<div v-else>
					<div class="relative">
						<MkInput
							name="Serial number"
							rules="required"
							class="mb-4"
							variant="outline"
							label="Serial number"
							:value="value.serialNumber"
							@input="updateForm('serialNumber', $event), checkSerialNumber()"
						/>
						<p
							v-show="(value.serialNumber != '' && errorMsg) || DEVICE_ERROR_MSG"
							class="text-error-20 text-sm"
							role="alert"
							aria-live="polite"
						>
							{{ errorMsg || DEVICE_ERROR_MSG }}
						</p>
						<div
							class="inline-block absolute right-0 top-0 transform translate-y-5 group p-0.5 mk-tooltip"
							role="tooltip"
							tabindex="0"
						>
							<span class="icon-notification" aria-label="Features auto-refills tooltip"></span>
							<MkCartTooltip class="hidden group-hover:block" :rotate-left="true" :icon-position="toolTipPosition">
								<template #tooltipRightValue>
									<p>Your 19-digit serial number can be found:</p>
									<p>. In the app (Settings > Technical info)</p>
									<p>. On the box’s shipping label</p>
									<p>. On the bottom of the device</p>
									<p
										>.
										<a class="text-white" target="_blank" :href="`https://help.molekule.com/hc/en-us/requests/new`"
											>Still need help?</a
										></p
									>
								</template>
							</MkCartTooltip>
						</div>
					</div>
					<div class="relative">
						<MkInput
							:name="estimatedDate"
							rules="required|date"
							class="mb-4"
							variant="outline"
							:label="estimatedDate"
							:value="value.purchaseDate"
							@input="updateForm('purchaseDate', $event)"
						/>
						<div class="inline-block absolute right-0 top-0 transform translate-y-5 group ml-2 mk-tooltip">
							<span class="font-primary-font-light text-base leading-6 pointer-events-none">MM/DD/YYYY</span>
						</div>
					</div>
				</div>
			</div>
			<div v-if="!registerUser" class="flex w-full items-center">
				<ValidationProvider
					v-slot="{ errors, ariaMsg }"
					rules="required"
				>
					<label class="inline-flex items-top mt-8 lg:mt-10">
						<input
							id="accepted"
							v-model="value.accepted"
							type="checkbox"
							class="ml-0.5 w-6 h-6 text-black rounded-full checked:border-transparent focus:ring-1 focus:outline-none active:ring-0 mk-checkbox focus:border-black"
							@change="
							updateForm(
								'accepted',
								$event.target.checked ? '1' : ''
							)
						"
						/>
						<span
							class="ml-4 font-primary-font-light leading-6 text-base q-reg-terms"
							for="accepted"
						>
							<p tabindex="0" class="font-primary-font-light text-base">
								Accept our
								<a class="hover:underline font-primary-font-bold" href="https://molekule.com/legal#terms" target="_blank">terms of service</a> and
								<a class="hover:underline font-primary-font-bold" target="_black" href="https://molekule.com/legal#privacy">privacy policy.</a>
							</p>
						</span>
					</label>
					<p
						v-show="errors"
						class="text-error-20 text-sm pl-11"
						v-bind="ariaMsg"
					>
						{{ errors[0] }}
					</p>
				</ValidationProvider>
			</div>
			<div class="flex justify-center items-center mt-10 mb-8 md:mb-12 lg:mb-10">
				<MkSecondaryButton
					:loading="loading"
					class="leading-5 h-8 w-full md:w-270 lg:w-345"
					:button-title="'Submit'"
					mksecondary-width="w-full py-0"
					@click="submit()"
				/>
			</div>
		</ValidationObserver>
	</div>
</template>
<script>
import { ValidationObserver,ValidationProvider } from 'vee-validate';
import { mapState } from 'vuex';
import MkStepProgress from '~/components/D2C/atoms/MkStepProgress.vue';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MkCartTooltip from '~/components/D2C/atoms/MkCartTooltip.vue';
import MkSecondaryButton from '~/components/D2C/atoms/MkSecondaryButton.vue';
import MkNotificationSuccess from '~/components/D2C/atoms/MkNotificationSuccess.vue';
export default {
	name: 'MkCreateAccount',
	components: {
		MkStepProgress,
		MkInput,
		MkCartTooltip,
		MkSecondaryButton,
		MkNotificationSuccess,
		ValidationObserver,
		ValidationProvider
	},
	props: {
		stepsCompleted: {
			type: Number,
			default: null,
		},
		value: {
			type: Object,
			default: () => {},
		},
		title: {
			type: String,
			default: 'Device details',
		},
		estimatedDate: {
			type: String,
			default: 'Est. purchase date',
		},
		gift: {
			type: Boolean,
			default: false,
		},
		deviceDetails:{
			type: Object,
			default: () => {},
		}
	},
	data() {
		return {
			warning: false,
			loading: false,
			stepNumber: 2,
			emailExists: false,
			formData: {},
			waitInterval: 1000,
			timer: null,
			checkingStatus: false,
			toolTipPosition: null,
			registerUser: false,
			errorMsg: '',
			validSerial: true,
			isUserExists: false,
		};
	},
	computed: {
		...mapState('USER_STORE', ['CUSTOMERID', 'DEVICE_ERROR_MSG', 'DEVICE']),
		...mapState('QUICK_REGISTER_STORE',['REGISTRATION_RESPONSE'])
	},
	watch: {
		title: {
			deep: true,
			handler() {
				this.handelShow();
			},
		},
	},
	methods: {
		updateForm(fieldName, value) {
			this.checkUserIfExists(value);
			this.formData[fieldName] = value;
			this.$set(this.value, fieldName, value);
			// this.$emit('input', this.value)
		},
		checkUserIfExists(email) {
			const regex = /^\w+([\+.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/; // eslint-disable-line
			const isValidEmail = regex.test(email);
			if (!isValidEmail) {
				return;
			}
			this.checkingStatus = false;
			clearTimeout(this.timer);
			this.timer = setTimeout(async () => {
				this.checkingStatus = true;
				this.isUserExists = await this.$store.dispatch('USER_STORE/USER_EXISTENCE_CHECK', { email, source: 'D2C_WEB' });
				this.checkingStatus = false;
			}, this.waitInterval);
		},
		showLogin() {
			this.isUserExists = false;
			this.$emit('sign-in',this.value);
		},
		async submit() {
			try {
				const isValidForm = await this.$refs.create_account_validation_observer.validate();
				if (isValidForm) {
					if (!this.registerUser) {
						this.loading = true;
						this.formData.channel = 'D2C';
						this.formData.quick_reg_phone_number = '2323232323';
						await this.$store.dispatch('QUICK_REGISTER_STORE/API_REGISTER', this.formData);
						if(this.REGISTRATION_RESPONSE && this.REGISTRATION_RESPONSE.success) {
							await this.$store.dispatch('USER_STORE/GET_PROFILE');
							// Successful account creation
							await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
							await this.$store.dispatch('CART_STORE/MERGE_CART');
							if(this.deviceDetails && this.deviceDetails.serialNumber){
								let payload ={
									customerId:this.CUSTOMERID,
									purchaseDate:this.deviceDetails.purchaseDate,
									serialNumber:this.deviceDetails.serialNumber,
									gift:this.gift
								}
								await this.$store.dispatch('USER_STORE/DEVICE_REGISTER',payload);
								if (this.DEVICE && this.DEVICE.serialNumber) {
									let payload = {
										customerId:this.CUSTOMERID,
										purchaseDate:this.$options.filters.formatDateAurora(this.DEVICE.purchaseDate, 'YYYY-MM-DD'),
										serialNumber:this.DEVICE.serialNumber
									}
									await this.$store.dispatch('USER_STORE/CREATE_SUBSCRIPTION',payload)
									this.$router.push('/D2C/account/autoRefills/');
								}else{
									this.$emit('device-register-fail',this.deviceDetails)
								}
							}
						}
						if (this.REGISTRATION_RESPONSE.emailDuplicate) {
							this.$refs.create_account_validation_observer.reset()
							this.$refs.create_account_validation_observer.setErrors({
								quick_reg_email_address: [
									'Email already associated with an account. Please sign in.',
								],
							})
						}
					} else if (this.validSerial) {
						this.loading = true;
						let payload ={
							customerId:this.CUSTOMERID,
							purchaseDate:this.value.purchaseDate,
							serialNumber:this.value.serialNumber,
							gift:this.gift
						}
						await this.$store.dispatch('USER_STORE/DEVICE_REGISTER', payload);
						if (this.DEVICE && this.DEVICE.serialNumber) {
							let payload = {
								customerId:this.CUSTOMERID,
								purchaseDate:this.$options.filters.formatDateAurora(this.DEVICE.purchaseDate, 'YYYY-MM-DD'),
								serialNumber:this.DEVICE.serialNumber
							}
							await this.$store.dispatch('USER_STORE/CREATE_SUBSCRIPTION',payload)
							this.$router.push('/D2C/account/autoRefills/');
						}
					}
				}
				this.loading = false;
			} catch (error) {
				this.loading = false;
			}
		},
		handelShow() {
			if (this.title === 'Device details') {
				this.registerUser = true;
			} else {
				this.registerUser = false;
			}
			if(this.$refs && this.$refs.create_account_validation_observer){
				this.$refs.create_account_validation_observer.reset()
			}
		},
		async checkSerialNumber() {
			try {
				const id = this.formData.serialNumber;
				this.$store.commit('USER_STORE/SET_DEVICE_ERROR_MSG', '');
				const res = await this.$repositories.user.checkDeviceSerial(id);
				if (res.status === 200 && res.data) {
					const { error, output } = res.data;
					if (error) {
						this.errorMsg = error.message;
						this.validSerial = false;
					} else if (output && output.status && output.status === 'Failed') {
						this.errorMsg = output.message;
						this.validSerial = false;
					} else if (output && output.status && output.status === 'Success') {
						this.errorMsg = '';
						this.validSerial = true;
					}
				}
			} catch (error) {}
		},
	},
};
</script>
